<template>
  <div id="index">
    <data-table :fields="fields" :opera="opera" :data="list" :total="total" @query="search" @edit="toEdit" @delete="toDelete">
      <template #selfbtn>
        <!-- <el-button type="primary" size="mini" @click="toAdd">添加</el-button> -->
      </template>
      <template #options="{ item }">
        <template v-if="item.prop === 'type'">
          <el-option v-for="(i, index) in typeList" :key="`type-${index}`" :label="i" :value="i"></el-option>
        </template>
      </template>
    </data-table>
  </div>
</template>

<script>
const { policyType, policyStatus } = require('@common/dict/index');
import { mapState, createNamespacedHelpers } from 'vuex';
const { mapActions: policy } = createNamespacedHelpers('policy');
export default {
  name: 'policyIndex',
  props: {},
  components: {},
  data: function () {
    return {
      list: [],
      total: 0,
      opera: [
        {
          label: '审核',
          method: 'edit',
          // display: (i) => i.status === '0',
        },
      ],
      fields: [
        { label: '申请单位', prop: 'company' },
        { label: '申请类型', prop: 'type', filter: 'select' },
        { label: '申请人', prop: 'apply_personal' },
        { label: '联系电话', prop: 'phone' },
        {
          label: '审核状态',
          prop: 'status',
          format: (i) => {
            const r = policyStatus.find((f) => f.value === i);
            if (r) return r.label;
            else return '';
          },
        },
        { label: '建议', prop: 'desc', showTip: true },
      ],
      typeList: policyType,
    };
  },
  created() {
    this.search();
  },
  methods: {
    ...policy(['query', 'delete']),
    async search({ skip = 0, limit = 10, ...info } = {}) {
      const res = await this.query({ skip, limit, ...info });
      if (this.$checkRes(res)) {
        this.$set(this, `list`, res.data);
        this.$set(this, `total`, res.total);
      }
    },
    toAdd() {
      this.$router.push('/adminCenter/policy/detail');
    },
    toEdit({ data }) {
      this.$router.push({ path: '/adminCenter/policy/detail', query: { id: data._id } });
    },
    async toDelete({ data }) {
      const res = await this.delete(data._id);
      if (this.$checkRes(res, '删除成功', '删除失败')) {
        this.search();
      }
    },
  },
  computed: {
    ...mapState(['user', 'menuParams']),
    pageTitle() {
      return `${this.$route.meta.title}`;
    },
  },
  metaInfo() {
    return { title: this.$route.meta.title };
  },
};
</script>

<style lang="less" scoped></style>
